#ifndef binpatt_h
#define binpatt_h

#include <vector>
#include <string>
#include "PatternMatrix.h"

class BinaryPatternSequence {
public:
	bool has_data;
	bool *binary_patsequence;       // (array) shows the nucleotides that match with the pattern
	int  *starting_positions;    // (array) shows patterns beginings (0 = no / len = +strand / -len = -strand)
	std::string original_pattern;

	void SetArray( unsigned long, std::string, std::string );
	void SetSize( unsigned long );
	void FreeMemory();
	void MergeArrays( BinaryPatternSequence * );
	void RenameElement( unsigned long, std::string&, std::string& );

	double CalculateDistance( BinaryPatternSequence *, unsigned long );

	void InitializeMatrix( std::string, double, double );
	std::string PrintPatternMatrix( FILE* );
	void MergePatternMatrix( BinaryPatternSequence * );

	BinaryPatternSequence();
	~BinaryPatternSequence();
private:
	PatternMatrix *pat_matrix;	
	unsigned long pattern_length;
	unsigned long array_size;
};

#endif
