#include <iostream>
#include <stdio.h>
#include <string>
#include <vector>
#include "SequenceArray.h"
#include "Sequence.h"

using namespace std;

//*********************************************************************************************************//
SequenceArray::SequenceArray() {
	combined_sequence = "";
};
//*********************************************************************************************************//
SequenceArray::~SequenceArray() {
	combined_sequence = "";
};
//*********************************************************************************************************//
void SequenceArray::SetSequence(vector<std::string> sequence_vector, unsigned long sequence_length) {
	unsigned long len(0);
	combined_sequence = "";
	string temp_sequence;
	
	for (unsigned int i = 0; i < sequence_vector.size(); ++i) {
		temp_sequence = sequence_vector[i];
		Sequence sequence;	
		temp_sequence = sequence.UpperCase(temp_sequence);
		len = sequence.PromoterLength(temp_sequence);

		if (len <= sequence_length) {
			combined_sequence = combined_sequence + temp_sequence;
		} else {
			combined_sequence = combined_sequence + temp_sequence.substr( (len - sequence_length ), sequence_length);
		}
		combined_sequence = combined_sequence + "$";
	}
};
//*********************************************************************************************************//
string SequenceArray::GetSequence() {
	return combined_sequence;
};
//*********************************************************************************************************//
void SequenceArray::CalculateATGC(double &at, double &cg) {
	double total(0);
	for (unsigned int i = 0; i < combined_sequence.size(); ++i) {
		if (combined_sequence.at(i) == 'A' || combined_sequence.at(i) == 'a' || combined_sequence.at(i) == 'T' || combined_sequence.at(i) == 't') {
			++at;
			++total;
		} 
		if (combined_sequence.at(i) == 'C' || combined_sequence.at(i) == 'c' || combined_sequence.at(i) == 'G' || combined_sequence.at(i) == 'g') {
			++cg;
			++total;
		}
	}
	at = at / total;
	cg = cg / total;
};
//*********************************************************************************************************//
